#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/ioctl.h>
#ifdef VMS
#include <unixio.h>
#else
#include <sys/mtio.h>
#endif
#include <math.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <time.h>
#include <signal.h>

#include "incub8r3.h"
#include "rwutils.c"

struct GlobalData {
  FILE *CubeFile;
  FILE *ScrFile;
  FILE *LogFile;
  char CubeFileName[256];
  int  ScrSize, RecordSize;
  char TapeDev[256];
  int  SwapTapeBytes;
  int  length;     /* length of axis on cube */
  int  nummc;      /* number of minicubes */
  int  numscr;     /* number of records written to scrfile */
  int  adcmax;
  int  numrecs;    /* current number of records in cube file */
  int  gotsignal;  /* a signal was caught by signal handler */
} gd;

int dbinfo[10];

char *tbuf;           /* tape buffer */
int ret;

int
read_tape(int fd)
{
  printf("fd = %d\n",fd);
  ret=0;
  int i;
  int n=0;
  short g;
  while(!feof(stdin))
  {
    ret = read(fd,tbuf,2);
    //printf("ret = %d\n",ret);
    memcpy(&g, tbuf, sizeof(g));
    //printf("n = %d, g = %d\n",n,g);
    n++;
    if (ret < 0)
    {
      return -1;
    }
  }
  printf("end of file reached, n = %d",n);
  return ret;
}

int
main (int argc, char **argv)
{
  char* tnam;
  tnam = argv[1];
  int tfd=0;
  int i;
  int elist[RW_MAXMULT], gemult;

  gd.RecordSize = 10000;

  if(!(tbuf=(char *) malloc(gd.RecordSize)))
  {
    printf("Could not malloc buffer for tbuf of %d bytes.\n",gd.RecordSize);
    exit(-1);
  }
    if((tfd = open(tnam, O_RDONLY | O_LARGEFILE)) <=0)
    {
      printf("\007 ERROR -- Could not open %s for reading.\n",tnam);
    }
    printf("tfd = %d\n",tfd);
    i = read_tape(tfd);
    printf("i = read_tape(%d) = %d",tfd,i);
 // }
  return 0;
}

